# This file is part of the Omaha Board-Game GUI.
# Copyright (C) 2009-2015  Yann Dirson
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation,
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

__all__ = [ 'Parametrizable', 'ParametrizableABCMeta', 'parameter',
            'setparam',
            'ParametrizableOuterclass', 'ParametrizableOuterclassABCMeta' ]

from .misc import class_fullname, hashable
from .params import Param, dep_ordered_params, fresh_parameters_for_decls
from .innerclass import OuterClass

import logging
from abc import ABCMeta

logger = logging.getLogger('Overlord.parametrizable')

def parameter(declarer):
    """Decorator to create a `parameter` from just a parameter declaration.

    The parameter's getter and setter are autogenerated.  The name of
    the class defining the parameter is unfortunately required, to create a
    "private" attribute to store the value.

    Usage:
        class C(object):
            @parameter
            def foo(cls, context):
                return Overlord.params.Int(...)
    """
    # FIXME: this def could be cached
    return ParameterAttribute(declarer)

class ParameterAttribute(object):
    def __init__(self, declarer):
        self.declarer = declarer
        self.xform = None
        self.classname = None # to be set at class construction time by metaclass
    def __get__(self, obj, objtype=None):
        if obj is None:
            return self
        param_attr = getattr(objtype, self.declarer.__name__)
        p = param_attr.fget_param(obj)
        assert hasattr(p, 'value'), '{0} is not a Param: {1!r}'.format(self.declarer.__name__, p)
        return p.value if param_attr.xform is None else param_attr.xform(obj, p.value)
    def __set__(self, obj, value):
        obj.set_params({ self.declarer.__name__: value })

    def xformer(self, func):
        self.xform = func
        return self

    # direct access to Param object
    def __attrname(self):
        assert self.classname
        return '_{0}__{1}'.format(self.classname, self.declarer.__name__)
    def fget_param(self, obj):
        return getattr(obj, self.__attrname())
    def fset_unsafe(self, obj, param):
        setparam(obj, self.__attrname(), param)

class ParametrizableType(type):
    """Metaclass for Parametrizable objects.

    Allows concision in parameter declaration through the @parameter
    decorator, and takes care of initializing the parameters' values
    at object construction time, taking preferences in account.
    """
    def __init__(cls, name, bases, attribs):
        super(ParametrizableType, cls).__init__(name, bases, attribs)
        # register @parameter declarers
        for pname, p in attribs.iteritems():
            if isinstance(p, ParameterAttribute):
                p.classname = cls.__name__
                cls._param_attributes()[pname] = p
    def __call__(cls, *args, **kwargs):
        if 'paramvalues' in kwargs:
            paramvalues = kwargs['paramvalues']
            del kwargs['paramvalues']
        else:
            paramvalues = {}
        # FIXME: should update context from here ?
        self = super(ParametrizableType, cls).__call__(*args, **kwargs)

        # Register class in prefs and initialize instance params from prefs.

        logger.debug("%s: init default params", self)
        # Frozen version of our context for the prefs
        frozencontext = hashable(self.context)
        app = self.context["app"]
        # notify the prefs of our existence (useful if we inherit
        # Parametrizable but have no parameter)
        app.prefs.register(frozencontext)

        for paramid, param in \
                self.fresh_parameters_for(app.plugin_manager, self.context).items():
            # paramvalues override ParamDecl defaults
            if paramid in paramvalues:
                param.value = paramvalues[paramid]
            # register in prefs if not done already: prefs have prevalence
            if not app.prefs.pref_loaded(frozencontext, paramid):
                app.prefs.record_param(frozencontext, paramid, param)

        # set from prefs
        assert frozencontext == hashable(self.context)
        self.set_params(app.prefs.get(self))

        return self

class ParametrizableABCMeta(ParametrizableType, ABCMeta):
    "The minimal metaclass inheriting ParametrizableType and ABCMeta."

class ParametrizableOuterclass(ParametrizableType, OuterClass):
    "The minimal metaclass inheriting ParametrizableType and OuterClass."

class ParametrizableOuterclassABCMeta(ParametrizableOuterclass, ABCMeta):
    "The minimal metaclass inheriting ParametrizableOuterclass and ABCMeta."

class Parametrizable(object):
    __metaclass__ = ParametrizableType

    # to be overriden to base class of each pzable hierarchy
    context_key = None

    # FIXME: document in some way that this class is a *unique* hierarchy root
    def __init__(self, parentcontext, paramvalues=None, **kwargs):
        if paramvalues is None:
            paramvalues = {}
        super(Parametrizable, self).__init__(**kwargs)
        assert self.context_key, \
               'Parametrizable class {0!r} does not provide a context_key'.format(type(self))
        self.context = dict(parentcontext)
        assert self.context_key not in self.context
        self.context[self.context_key] = type(self)

    def clone(self):
        context = dict(self.context)
        del context[self.context_key]
        c = type(self)(parentcontext=context)
        return c

    @classmethod
    def parameters_dcl(cls, context):
        """
        Return a dict of parameter declarations.

        Dict keys are string identifiers, each value is an instance of
        (a subclass of) Core.Param.

        This is the top of the Parametrizable hierarchy, and it takes
        care of the parameters declared using the parameter() annotation.
        """
        p = dict()
        for (paramid, param_attr) in cls.param_attributes().iteritems():
            p[paramid] = param_attr.declarer(cls, context)
        return p

    def set_params(self, params):
        """
        Apply parameters to self.

        This is the top of the Parametrizable hierarchy, and it takes
        care of the parameters declared using the @parameters annotation.
        """
        logger.debug("set_params(%s)", params)
        for paramid, param in dep_ordered_params(params, refobj=self):
            if not hasattr(self, paramid):
                assert isinstance(param, Param), \
                       "%s %s is not a Param" % (type(param), param)
            getattr(type(self), paramid).fset_unsafe(self, param)

    # we must ensure that each class in the hierarchy has its own
    # param_attributes, and that they do not inherit it by mistake
    @classmethod
    def _param_attributes(cls):
        "The @parameter's declared for `cls`, not including the parent's."
        attrname = '_{0}__param_attributes'.format(cls.__name__)
        if not hasattr(cls, attrname):
            setattr(cls, attrname, dict())
        return getattr(cls, attrname)
    @classmethod
    def param_attributes(cls):
        "All @parameter's for `cls`, including those inherited from the parents."
        d = {}
        for c in reversed(cls.mro()):
            if not hasattr(c, "_param_attributes"):
                # not all superclasses have to be Parametrizable, object is not :)
                continue
            d.update(c._param_attributes())
        return d

    @classmethod
    def fresh_parameters_for(cls, plugin_manager, context):
        return fresh_parameters_for_decls(cls.parameters_dcl(context),
                                          plugin_manager)

    @classmethod
    def preference_key(cls):
        """
        Return the key under which to store object's parameters in the prefs.
        """
        return class_fullname(cls)

def setparam(obj, attrname, value):
    "Param-aware replacement for setattr."
    if isinstance(value, Param):
        # create or replace the Param
        if hasattr(obj, attrname):
            logger.debug("Replace %s.%s = %r", obj, attrname, value.value)
        else:
            logger.debug("Initialize %s.%s = %r", obj, attrname, value.value)
        setattr(obj, attrname, value)
    else:
        # just change the value
        logger.debug("Value change %s.%s = %r", obj, attrname, value)
        getattr(obj, attrname).value = value
